<?php
/*
 * Filename.....: class_mdb.php
 * Class........: mdb
 * Aufgabe......: open *.mdb MSAccess files
 * Erstellt am..: Donnerstag, 17. Juni 2004, 23:32:07
 *       _  __      _ _
 *  ||| | |/ /     (_) |        Wirtschaftsinformatiker IHK
 * \. ./| ' / _ __  _| |_ ___   www.ingoknito.de
 * - ^ -|  < | '_ \| | __/ _ \  
 * / - \| . \| | | | | || (_) | Peter Klauer
 *  ||| |_|\_\_| |_|_|\__\___/  
 * mailto.......: knito@knito.de
 *
 * Changes:
 * 2004-07-21: added function fieldcount()
 * //changes by paresy
 * 2005-04-01: updated for PHP5
 *             added return values
 */

class mdb
{
  
  public $RS = 0;
  public $ADODB = 0;
  
  public $strProvider = 'Provider=Microsoft.Jet.OLEDB.4.0';
  public $strMode     = 'Mode=ReadWrite';
  public $strPSI      = 'Persist Security Info=False';
  public $strDataSource  = '';
  public $strConn     = '';
  public $strRealPath = '';
  
  function mdb( $dsn='Please enter DataSource!' )
  {
    $this->strRealPath = realpath( $dsn );
    if( strlen( $this->strRealPath ) > 0 )
    {
      $this->strDataSource = 'Data Source='.$this->strRealPath;
    }
    else
    {
      echo "<br>mdb::mdb() File not found $dsn<br>";
      return false;
    }
  } // eof constructor mdb()
  
  
  function open( )
  {
    if( strlen( $this->strRealPath ) > 0 )
    {
  
      $this->strConn = 
        $this->strProvider.';'.
        $this->strDataSource.';'.
        $this->strMode.';'.
        $this->strPSI;
        
      $this->ADODB = new COM( 'ADODB.Connection' );
      
      if( $this->ADODB )
      {
        $this->ADODB->open( $this->strConn );
	return true;
      }
      else
      {
        echo 'mdb::open() ERROR with ADODB.Connection<br>'.$this->strConn;
	return false;
      }
    }
  } // eof open()
  
  function close()
  {
    $this->RS->Close();
    $this->RS=null;
  
    $this->ADODB->Close();
    $this->ADODB=null;
  } // eof close()

  function execute( $strSQL )
  {
    $this->RS = $this->ADODB->execute( $strSQL );
  } // eof execute()
  
  function eof()
  {
    return $this->RS->EOF;
  } // eof eof()
  
  function movefirst()
  {
    $this->RS->MoveFirst();
  } // eof movefirst()

  function movenext( )
  {
    $this->RS->MoveNext();
  } // eof movenext()
  
  function fieldvalue( $fieldname )
  {
    return $this->RS->Fields[$fieldname]->value;
  } // eof fieldvalue()
  
  function fieldname( $fieldnumber )
  {
    return $this->RS->Fields[$fieldnumber]->name;
  } // eof fieldname()
  
  function fieldcount( )
  {
    return $this->RS->Fields->Count;
  } // eof fieldcount()  
  
} // eoc mdb
?>
